routes/web.php
<?php

use Illuminate\Support\Facades\Route;
use App\Http\Controllers\EventController;
use App\Http\Controllers\SubjectController;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
});

Auth::routes();

Route::get('/home', [App\Http\Controllers\HomeController::class, 'index'])->name('home');
Route::resource('events', EventController::class);
Route::get('/subjects/roulette', [SubjectController::class, 'roulette'])->name('subjects.roulette');
Route::resource('subjects', SubjectController::class);

app/Models/Event.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Event extends Model
{
    protected $fillable = ['location', 'date'];
    use HasFactory;
}

app/Models/Subject.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Subject extends Model
{
    protected $fillable = ['description', 'used'];
    use HasFactory;
}

app/Models/User.php
<?php

namespace App\Models;

use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Notifications\Notifiable;

class User extends Authenticatable
{
    use HasFactory, Notifiable;

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'name',
        'email',
        'password',
        'statut'
    ];

    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = [
        'password',
        'remember_token',
    ];

    /**
     * The attributes that should be cast to native types.
     *
     * @var array
     */
    protected $casts = [
        'email_verified_at' => 'datetime',
    ];

    public function isAdmin() {
        dd($this->statut);
        return $this->statut == '1';
    }
}

app/Http/Controllers/Controller.php
<?php

namespace App\Http\Controllers;

use Illuminate\Foundation\Auth\Access\AuthorizesRequests;
use Illuminate\Foundation\Bus\DispatchesJobs;
use Illuminate\Foundation\Validation\ValidatesRequests;
use Illuminate\Routing\Controller as BaseController;

class Controller extends BaseController
{
    use AuthorizesRequests, DispatchesJobs, ValidatesRequests;
}

app/Http/Controllers/EventController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Models\Event;
use App\Http\Requests\Event as EventRequest;

class EventController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        return view('home');
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        // $this->authorize('create');
        return view('event');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(EventRequest $eventRequest)
    {
        Event::create($eventRequest->all());
        return redirect()->route('home')->with('info', 'L évent a bien été créé');
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
    }
}

app/Http/Controllers/HomeController.php
<?php

namespace App\Http\Controllers;
use App\Models\Event;

use Illuminate\Http\Request;

class HomeController extends Controller
{
    /**
     * Create a new controller instance.
     *
     * @return void
     */
    public function __construct()
    {
        $this->middleware('auth');
    }

    /**
     * Show the application dashboard.
     *
     * @return \Illuminate\Contracts\Support\Renderable
     */
    public function index()
    {
        $events=Event::whereDate('date', '>=', date('Y-m-d'))
        ->orderBy('date', 'asc')
        ->get();
        return view('home', compact('events'));
    }
}

app/Http/Controllers/SubjectController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Models\Subject;
use App\Http\Requests\Subject as SubjectRequest;

class SubjectController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        return view('home');
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(SubjectRequest $subjectRequest)
    {
        Subject::create($subjectRequest->all());
        return redirect()->route('home')->with('info', 'Le sujet a bien été créé');
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
    }

    /**
     * Display a roulette.
     *
     * @return \Illuminate\Http\Response
     */
    public function roulette()
    {
        $randomSubject = subject::where('used',0)
                ->inRandomOrder()
                ->first();
        if (is_null($randomSubject)) {
            return redirect()->route('home')->with('info', 'Plus de sujets');
        } else {
        subject::where('id', $randomSubject->id)
                ->update(['used' => 1]);
        return view('roulette',  compact('randomSubject'));
        }
    }

}

resources/views/create.blade.php
@extends('layouts.app')

@section('content')
<div class="row justify-content-center">
    <div class="col-md-8">
        <div class="card">
            <div class="card-header">
                <h2 class="text-center">Créer un sujet</h2>
            </div>
            <div class="card-body text-center ">
                <form class=" d-flex flex-column align-items-center" action="{{ route('subjects.store') }}" method="POST">
                    @csrf
                    <div class="field">
                        <label for="FormControlAddSubject">Sujet</label>
                        <div class="control">
                            <textarea class="textarea" name="description" id="formAddSubject" rows="3">{{ old('description') }}</textarea>
                        </div>
                    </div>
                    @error('description')
                    <p class="help is-danger">{{ $message }}</p>
                    @enderror
                    <div class="field">
                    <div class="control">
                        <button style="border-radius: 25px" class="btn btn-primary mr-5">Envoyer</button>
                    </div>
                    </div>
                </form>
            </div>
        </div>
    </div>
</div>

@endsection

resources/views/event.blade.php
@extends('layouts.app')

@section('content')
<div class="row justify-content-center">
    <div class="col-md-8">
        <div class="card">
            <div class="card-header">
                <h2 class="text-center">Créer un event</h2>
            </div>
            <div class="card-body text-center ">
                <form class=" d-flex flex-column align-items-center " action="{{ route('events.store') }}" method="POST">
                    @csrf
                    <div class="field">
                        <label for="FormControlAddEvent ">Lieu</label>
                        <div class="control">
                            <input class="input @error('location') is-danger @enderror" type="text" name="location" value="{{ old('location') }}" placeholder="Lieu de l'évent">
                        </div>
                    </div>
                    @error('location')
                    <p class="help is-danger">{{ $message }}</p>
                    @enderror
                    <label class="mr-4">Date de l'évent</label>
                    <div class="control">
                        <input class="input" type="date" name="date" value="{{ old('date') }}" min="{{ date('Y-m-d') }}">
                    </div>
                    @error('date')
                        <p class="help is-danger">{{ $message }}</p>
                    @enderror
                    <div class="field">
                    <div class="control">
                        <button style="border-radius: 25px" class="btn btn-primary mr-5">Envoyer</button>
                    </div>
                    </div>
                </form>
            </div>
        </div>
    </div>
</div>

@endsection

resources/views/home.blade.php
@extends('layouts.app')

@section('content')

{{-- @if(session()->has('info'))
<div class="notification is-success">
    {{ session('info') }}
</div>
@endif --}}
<table class="table">
    <thead>
        <tr>
            <th scope="col">Lieu</th>
            <th scope="col">Date</th>
        </tr>
    </thead>
    <tbody>
        <?php
            setlocale(LC_TIME, 'french.UTF-8', 'fr_FR.UTF-8');
        ?>
        @foreach ($events as $event)
        <tr>
            <th scope="row">{{ $event->location }}</th>
            <td>{{ strftime("%A %d %B %G", strtotime($event->date))}}</td>
        </tr>
        @endforeach
    </div>
</div>

@endsection

resources/views/layouts/app.blade.php
<!doctype html>
<html lang="{{ str_replace('_', '-', app()->getLocale()) }}">
<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">

    <!-- CSRF Token -->
    <meta name="csrf-token" content="{{ csrf_token() }}">

    <title>{{ config('app.name', 'Laravel') }}</title>

    <!-- Scripts -->
    <script src="{{ asset('js/app.js') }}" defer></script>

    <!-- Fonts -->
    <link rel="dns-prefetch" href="//fonts.gstatic.com">
    <link href="https://fonts.googleapis.com/css?family=Nunito" rel="stylesheet">

    <!-- Styles -->
    <link href="{{ asset('css/app.css') }}" rel="stylesheet">
</head>
<body>
    <div id="app">
        <nav class="navbar navbar-expand-md navbar-light bg-white shadow-sm">
            <div class="container">
                <a class="navbar-brand" href="{{ url('/') }}">
                    {{ config('app.name', 'Laravel') }}
                </a>
                <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="{{ __('Toggle navigation') }}">
                    <span class="navbar-toggler-icon"></span>
                </button>

                <div class="collapse navbar-collapse" id="navbarSupportedContent">
                    <!-- Left Side Of Navbar -->
                    <ul class="nav justify-content-center">
                        <li class="nav-item">
                            <a class="nav-link" href="{{ route('home') }}">Home</a>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link" href="{{ route('events.create') }}">Event</a>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link" href="{{ route('subjects.create') }}">Sujet</a>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link" href="{{ route('subjects.roulette') }}">Roulette</a>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link" href="{{ route('register') }}">User</a>
                        </li>
                    </ul>
                    <ul class="navbar-nav mr-auto">

                    </ul>

                    <!-- Right Side Of Navbar -->
                    <ul class="navbar-nav ml-auto">
                        <!-- Authentication Links -->
                        @guest
                            @if (Route::has('login'))
                                <li class="nav-item">
                                    <a class="nav-link" href="{{ route('login') }}">{{ __('Login') }}</a>
                                </li>
                            @endif

                            @if (Route::has('register'))
                                <li class="nav-item">
                                    <a class="nav-link" href="{{ route('register') }}">{{ __('Register') }}</a>
                                </li>
                            @endif
                        @else
                            <li class="nav-item dropdown">
                                <a id="navbarDropdown" class="nav-link dropdown-toggle" href="#" role="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false" v-pre>
                                    {{ Auth::user()->name }}
                                </a>

                                <div class="dropdown-menu dropdown-menu-right" aria-labelledby="navbarDropdown">
                                    <a class="dropdown-item" href="{{ route('logout') }}"
                                       onclick="event.preventDefault();
                                                     document.getElementById('logout-form').submit();">
                                        {{ __('Logout') }}
                                    </a>

                                    <form id="logout-form" action="{{ route('logout') }}" method="POST" class="d-none">
                                        @csrf
                                    </form>
                                </div>
                            </li>
                        @endguest
                    </ul>
                </div>
            </div>
        </nav>

        <main class="py-4">
            @yield('content')
        </main>
    </div>
</body>
</html>

resources/views/roulette.blade.php
@extends('layouts.app')

@section('content')

<div class="row justify-content-center">
    <div class="col-md-8">
        <div class="card text-center">
            <div class="card-header">
                Sujet
            </div>
            <div class="card-body">
                <h5 class="card-title">{{ $randomSubject->description }}</h5>
                <a href="{{ route('subjects.roulette') }}" class="btn btn-primary">Roulette !!!!</a>
            </div>
        </div>
    </div>
</div>

@endsection